| IGLib 1.5 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | List of all members
IG.Num.PointCloud< PointContainerType, PointType > Class Template Reference

Cloud of points, contains a list of containers of objects that include point coordinates. More...

Inheritance diagram for IG.Num.PointCloud< PointContainerType, PointType >:
[legend]
Collaboration diagram for IG.Num.PointCloud< PointContainerType, PointType >:
[legend]

## Public Member Functions
| PointCloud ()
| PointCloud (params PointType[] points)
| Constructs a cloud of points containing the specified points. More...
| PointCloud (params IPointContainer< PointType >[] points)
| Constructs a cloud of points containing the points embedded in the specified point containers. More...
Public Member Functions inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
| PointCloud ()
| Constructs an empty cloud of points. More...
| PointCloud (params PointType[] points)
| Constructs a cloud of points containing the specified points. More...
| PointCloud (params IPointContainer< PointType >[] points)
| Constructs a cloud of points containing the points embedded in the specified point containers. More...
PointContainerType | GetPoint (int which)
| Returns the specified point identified by its position (index) within list of points. More...
void | SetPoints (params PointType[] points)
| Sets the points to be contained in the current point cloud. More...
void | AddPoints (params PointType[] points)
| Adds the specified points to the current point cloud. More...
void | SetPoints (params IPointContainer< PointType >[] points)
| Sets the points to be contained in the current point cloud to the specified set of points that are embedded in point containers. More...
void | AddPoints (params IPointContainer< PointType >[] points)
| Adds the specified points that are embedded in point containers to the current point cloud. More...
abstract DistanceComparer < PointContainerType, PointType > | CreateDefaultDistanceComparer (PointContainerType point)
| Creates and returnws a distance comparer of hte default type for the current type of point of clouds. More...
virtual DistanceComparer < PointContainerType, PointType > | CreateDefaultDistanceComparer ()
| Creates and returnws a distance comparer of hte default type for the current type of point of clouds. More...
abstract PointType | CreatePointFromCoordinates (IVector coordinates)
| Creates and returns a new point with specified coordinates. More...
abstract PointContainerType | CreatePointContainer (PointType point)
| Creates and returns a new point container that wraps the specified point. More...
virtual PointContainerType | CreatePointContainerFromCoordinates (IVector coordinates)
  | Creates and returns a new point container that wraps a newly created point with the specified coordinates. Parameters
  coordinates | Coordinates of the embedded point type. A copy of this vector is normally created to hold coordinates within the point, because the caller is allowed to modify coordinates on the vector.
More...
List< PointContainerType > | CreatePointsCopy ()
| Creates and returns a copy of list of points, containing references to points (point containers, in fact) contained in the current cloud of points. More...
PointType | CreateRandomPoint (IBoundingBox bounds)
| Creates and returns a new point with random co-ordinates that fall within the specified bounds (inclusively). More...
PointType | CreateRandomPoint (int spaceDimension, double minCoordinateValues, double maxCoordinateValues)
| Creates and returns a new point with random co-ordinates that fall within the specified bounds (inclusively). More...
PointType | CreateRandomPoint (int spaceDimension)
| Creates and returns a new point with random co-ordinates that fall between 0 and 1 (inclusively). More...
PointContainerType | CreateRandomPointContainer (IBoundingBox bounds)
| Creates and returns a new point container with random co-ordinates that fall within the specified bounds (inclusively). More...
PointContainerType | CreateRandomPointContainer (int spaceDimension, double minCoordinateValues, double maxCoordinateValues)
| Creates and returns a new point container with random co-ordinates that fall within the specified bounds (inclusively). More...
PointContainerType | CreateRandomPointContainer (int spaceDimension)
| Creates and returns a new point container with random co-ordinates that fall between 0 and 1 (inclusively). More...
void | GenerateRandomCloud (int numPoints, IBoundingBox bounds)
| Generates a specified number of random points with random co-ordinates that fall within the specified bounds (inclusively), and incorporates them into the current point cloud. Eventual existent points are removed from the cloud. More...
void | GenerateRandomCloud (int numPoints, int spaceDimension, double minCoordinateValues, double maxCoordinateValues)
| Generates a specified number of random points with random co-ordinates that fall within the specified bounds (inclusively), and incorporates them into the current point cloud. Eventual existent points are removed from the cloud. More...
void | GenerateRandomCloud (int numPoints, int spaceDimension)
| Generates a specified number of random points with random co-ordinates that fall between 0 and 1 (inclusively), and incorporates them into the current point cloud. Eventual existent points are removed from the cloud. More...
void | UpdateNeighborDistances (IDistanceComparer< PointContainerType, PointType > distanceComparer)
| Iterates through all points contained in the current cloud, and calculates and updates their distances to the containing point by the specified distance comparer. More...
void | GetNeighborDistanceStatistics (int numClosestPoints, ref int[] numSpecimens, ref IVector minDistances, ref IVector maxDistances, ref IVector averageDistances)
| Calculates a number of statistics on the distances of the first specified number of closest neighbors to each point, and stores them to the provided storage. More...
void | GetNeighborDistanceStatistics (int numClosestPoints, ref int[] numSpecimens, ref IVector minDistances, ref IVector maxDistances, ref IVector averageDistances, ref IVector standardDeviations, ref IVector averageAbsoluteDeviations, bool calculateDeviations)
| Calculates a number of statistics on the distances of the first specified number of closest neighbors to each point, and stores them to the provided storage. More...
void | PrintNeighborDistanceStatistics (int numClosestPoints, bool calculateDeviations, IDistanceComparer< PointContainerType, PointType > distanceComparer)
| Calculates and prints a number of statistics on the distances of the first specified number of closest neighbors to each point, and stores them to the provided storage. More...
void | TestClosestPointsWithOutputs (int numClosestPoints, bool printByComponents, bool printIndividualPointsComp, PointContainerType[] points, IDistanceComparer< PointContainerType, PointType > comparerInput, List< PointContainerType > trainingPoints)
| For each point (training element) in the specified array, the training points are sorted according to the distance to this point, and data for the specified number of closest points are written. More...
void | FindClosestPointsDummy (IDistanceComparer< PointContainerType, PointType > comparer, int numClosestPoints)
| Finds the specified number fo closest points to each point contained in the current cloud, and updates the neighbor lists of points such that they contain links to these neighbors. More...
void | FindClosestPointsDummy (IDistanceComparer< PointContainerType, PointType > comparer, int numClosestPoints, bool accelerateSortingByStoringDistances)
| Finds the specified number fo closest points to each point contained in the current cloud, and updates the neighbor lists of points such that they contain links to these neighbors. More...
void | FindClosestPointsGraph (IDistanceComparer< PointContainerType, PointType > comparer, int numClosestPoints)
| Finds closest points by initializing with random neighbors and then gradually improving connections to neighbors. More...

## Additional Inherited Members
Static Public Member Functions inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
static void | TestClosestPoints (int numClosestPoints, bool printByComponents, PointContainerType[] referencePoints, IDistanceComparer< PointContainerType, PointType > comparerInput, List< PointContainerType > trainingPoints)
| For each point in the specified array, the training points are sorted according to the distance to this point, and data for the specified number of closest points are written. More...
static void | TestClosestPoints (int numClosestPoints, bool printByComponents, bool printIndividualPointsComp, PointContainerType[] referencePoints, IDistanceComparer< PointContainerType, PointType > comparerInput, List< PointContainerType > trainingPoints)
| For each point in the specified array, the training points are sorted according to the distance to this point, and data for the specified number of closest points are written. More...
static PointCloudVector | ExampleClosestPointsDummy (int numPoints, int spaceDimension, int numClosestPoints)
| Creates rabndomly an example cloud of points, calculates the specified number of closest neighbors by the dummy method for each point in an example cloud, and prints statistics. More...
static PointCloudVector | ExampleClosestPointsDummy (int numPoints, int spaceDimension, int numClosestPoints, bool accelerateSortingByStoringDistances)
| Creates randomly an example cloud of points, calculates the specified number of closest neighbors by the dummy method for each point in an example cloud, and prints statistics. More...
Public Attributes inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
DistanceComparer < PointContainerType, PointType > | _distanceComparer
Protected Member Functions inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
void | PrintNeighborDistanceStatistics (int[] numSpecimens, IVector minDistances, IVector maxDistances, IVector averageDistances, IVector standardDeviations, IVector averageAbsoluteDeviations, bool calculateDeviations)
void | PrintNeighborDistanceStatistics (int[] numSpecimens, IVector minDistances, IVector maxDistances, IVector averageDistances)
Protected Attributes inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
List< PointContainerType > | _points = new List<PointContainerType>()
IVector | _auxVector
Properties inherited from IG.Num.PointCloud< PointLinkType, PointContainerType, PointType >
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
List< PointContainerType > | Points`[get]`
| List of points contained on the current class. More...
int | NumPoints`[get]`
| Gets the current number of points on the list. More...
PointContainerType | this[int which]`[get, protected set]`
| Returns the specified point identified by its position (index) within list of points. More...
DistanceComparer < PointContainerType, PointType > | DistanceComparer`[get, set]`
| Distance comparer of the current point cloud object. More...
IRandomGenerator | Rand`[get, set]`
| Random generator used by the current cloud of points. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`

## Detailed Description

Cloud of points, contains a list of containers of objects that include point coordinates.

Template Parameters

  PointContainerType | Type of point link that is used by point container.
  PointType | Type of objects that include point coordinates.

$A Igor Sep08 May09 Dec11;

Type Constraints

  PointContainerType | : | PointContainer |
  PointContainerType | : | PointLink |
  PointContainerType | : | PointContainerType |
  PointContainerType | : | PointType |
  PointContainerType | : | PointContainerType |
  PointContainerType | : | PointType |

## Constructor & Destructor Documentation

IG.Num.PointCloud< PointContainerType, PointType >.PointCloud | ( |  | ) |
| inline

IG.Num.PointCloud< PointContainerType, PointType >.PointCloud | ( | params PointType[] | points | ) |
| inline

Constructs a cloud of points containing the specified points.

Parameters

  points | Points that are included in the created point cloud.

IG.Num.PointCloud< PointContainerType, PointType >.PointCloud | ( | params IPointContainer< PointType >[] | points | ) |
| inline

Constructs a cloud of points containing the points embedded in the specified point containers.

All points are taken from their point containers and embedded in newly created point containers before adding to the created cloud of points.

Parameters

  points | Points embedded in point containers that are included in the created point cloud.

The documentation for this class was generated from the following file:

- igbase/numeric/geometry/pointclouds/PointCloud.cs